/* MODULE bnf_chk */

#include "m2runtime.c"

#ifndef M2_IMPORT_m2
	#include "m2.c"
	#define M2_IMPORT_m2
#endif

#ifndef M2_IMPORT_io
	#include "io.c"
	#define M2_IMPORT_io
#endif

#ifndef M2_IMPORT_str
	#include "str.c"
	#define M2_IMPORT_str
#endif

void bnf_chk_0err_entry_get(int i, char **m, char **f, int *l);
/* 19*/ STRING * bnf_chk_fn = NULL;
/* 20*/ int bnf_chk_do_report = 0;
/* 21*/ int bnf_chk_do_print_text = 0;
/* 22*/ int bnf_chk_do_print_html = 0;
/* 23*/ int bnf_chk_do_sort = 0;
/* 24*/ int bnf_chk_do_print_index = 0;
/* 25*/ int bnf_chk_tab_size = 0;
/* 26*/ int bnf_chk_print_file_name = 0;
/* 27*/ int bnf_chk_print_source = 0;
/* 30*/ int bnf_chk_print_context = 0;
/* 36*/ int bnf_chk_warn_invalid_unquoted_lit_str = 0;
/* 36*/ int bnf_chk_warn_invalid_eq = 0;
/* 36*/ int bnf_chk_warn_invalid_rule_terminator = 0;
/* 36*/ int bnf_chk_warn_invalid_id = 0;
/* 49*/ ARRAY * bnf_chk_ids = NULL;
/* 77*/ ARRAY * bnf_chk_decls = NULL;
/* 83*/ void * bnf_chk_fd = NULL;
/* 86*/ STRING * bnf_chk_line = NULL;
/* 89*/ int bnf_chk_line_n = 0;
/* 92*/ int bnf_chk_line_idx = 0;
/* 95*/ int bnf_chk_line_pos = 0;
/* 98*/ STRING * bnf_chk_c = NULL;
/*101*/ int bnf_chk_sym = 0;
/*105*/ STRING * bnf_chk_s = NULL;

/*107*/ STRING *
/*107*/ bnf_chk_String2HTML(STRING *bnf_chk_s)
/*107*/ {
/*107*/ 	bnf_chk_s = str_substitute(bnf_chk_s, m2runtime_CHR(38), (STRING *) "\0\0\0\0\5\0\0\000&amp;");
/*108*/ 	bnf_chk_s = str_substitute(bnf_chk_s, m2runtime_CHR(60), (STRING *) "\0\0\0\0\4\0\0\000&lt;");
/*109*/ 	bnf_chk_s = str_substitute(bnf_chk_s, m2runtime_CHR(62), (STRING *) "\0\0\0\0\4\0\0\000&gt;");
/*110*/ 	bnf_chk_s = str_substitute(bnf_chk_s, m2runtime_CHR(10), (STRING *) "\0\0\0\0\5\0\0\000<br>\012");
/*111*/ 	return bnf_chk_s;
/*115*/ }


/*117*/ void
/*117*/ bnf_chk_print_text(STRING *bnf_chk_s)
/*117*/ {
/*117*/ 	if( bnf_chk_do_print_html ){
/*118*/ 		bnf_chk_s = bnf_chk_String2HTML(bnf_chk_s);
/*119*/ 		bnf_chk_s = str_substitute(bnf_chk_s, m2runtime_CHR(9), (STRING *) "\0\0\0\0\10\0\0\000        ");
/*120*/ 		bnf_chk_s = str_substitute(bnf_chk_s, m2runtime_CHR(32), (STRING *) "\0\0\0\0\6\0\0\000&nbsp;");
/*121*/ 		bnf_chk_s = m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\6\0\0\000<code>", bnf_chk_s, (STRING *) "\0\0\0\0\7\0\0\000</code>", 1);
/*123*/ 	}
/*123*/ 	m2_print(bnf_chk_s);
/*127*/ }


/*129*/ void
/*129*/ bnf_chk_PrintLineSource(void)
/*129*/ {
/*129*/ 	bnf_chk_print_text(m2runtime_itos(bnf_chk_line_n));
/*130*/ 	bnf_chk_print_text((STRING *) "\0\0\0\0\2\0\0\000:\011");
/*131*/ 	bnf_chk_print_text(bnf_chk_line);
/*132*/ 	bnf_chk_print_text(m2runtime_CHR(10));
/*136*/ }


/*138*/ void
/*138*/ bnf_chk_read_ch(void)
/*138*/ {
/*139*/ 	if( bnf_chk_c == NULL ){
/*140*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(9)) == 0 ){
/*141*/ 		m2_inc(&bnf_chk_line_pos, bnf_chk_tab_size);
/*142*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(10)) == 0 ){
/*143*/ 		m2_inc(&bnf_chk_line_n, 1);
/*144*/ 		bnf_chk_line_pos = 1;
/*146*/ 	} else {
/*146*/ 		m2_inc(&bnf_chk_line_pos, 1);
/*150*/ 	}
/*150*/ 	if( bnf_chk_line == NULL ){
/*151*/ 		bnf_chk_c = NULL;
/*152*/ 	} else if( (bnf_chk_line_idx < m2runtime_length(bnf_chk_line)) ){
/*153*/ 		bnf_chk_c = m2runtime_substr(bnf_chk_line, bnf_chk_line_idx, 0, 0, bnf_chk_0err_entry_get, 0);
/*154*/ 		m2_inc(&bnf_chk_line_idx, 1);
/*155*/ 	} else if( (bnf_chk_line_idx == m2runtime_length(bnf_chk_line)) ){
/*156*/ 		bnf_chk_c = m2runtime_CHR(10);
/*157*/ 		m2_inc(&bnf_chk_line_idx, 1);
/*159*/ 	} else {
/*159*/ 		m2runtime_ERROR_CODE = 0;
/*159*/ 		bnf_chk_line = io_ReadLine(1, bnf_chk_fd);
/*160*/ 		switch( m2runtime_ERROR_CODE ){

/*160*/ 		case 0:  break;
/*160*/ 		default:
/*160*/ 			m2runtime_HALT(bnf_chk_0err_entry_get, 1, m2runtime_ERROR_MESSAGE);
/*160*/ 		}
/*160*/ 		if( bnf_chk_line == NULL ){
/*161*/ 			bnf_chk_c = NULL;
/*162*/ 		} else if( (m2runtime_length(bnf_chk_line) == 0) ){
/*163*/ 			bnf_chk_c = m2runtime_CHR(10);
/*165*/ 		} else {
/*165*/ 			bnf_chk_c = m2runtime_substr(bnf_chk_line, 0, 0, 0, bnf_chk_0err_entry_get, 2);
/*167*/ 		}
/*167*/ 		bnf_chk_line_idx = 1;
/*168*/ 		if( (bnf_chk_print_source && (bnf_chk_line != NULL)) ){
/*169*/ 			bnf_chk_PrintLineSource();
/*172*/ 		}
/*173*/ 	}
/*173*/ 	if( FALSE ){
/*174*/ 		m2_print(bnf_chk_c);
/*177*/ 	}
/*179*/ }


/*181*/ void
/*181*/ bnf_chk_message(STRING *bnf_chk_msg_type, STRING *bnf_chk_s)
/*181*/ {
/*181*/ 	if( bnf_chk_print_context ){
/*182*/ 		bnf_chk_print_text(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\2\0\0\000\012\011", bnf_chk_line, (STRING *) "\0\0\0\0\2\0\0\000\012\011", str_repeat(m2runtime_CHR(32), (bnf_chk_line_pos - 1)), (STRING *) "\0\0\0\0\10\0\0\000\134_ HERE\012", 1));
/*185*/ 	}
/*185*/ 	if( bnf_chk_print_file_name ){
/*186*/ 		bnf_chk_print_text(m2runtime_concat_STRING(0, bnf_chk_fn, (STRING *) "\0\0\0\0\2\0\0\000: ", 1));
/*189*/ 	}
/*189*/ 	bnf_chk_print_text(m2runtime_concat_STRING(0, EMPTY_STRING, m2runtime_itos(bnf_chk_line_n), m2runtime_CHR(58), m2runtime_itos(bnf_chk_line_pos), (STRING *) "\0\0\0\0\2\0\0\000: ", 1));
/*191*/ 	if( bnf_chk_do_print_html ){
/*192*/ 		m2_print((STRING *) "\0\0\0\0\3\0\0\000<b>");
/*194*/ 	}
/*194*/ 	bnf_chk_print_text(m2runtime_concat_STRING(0, bnf_chk_msg_type, (STRING *) "\0\0\0\0\2\0\0\000: ", bnf_chk_s, m2runtime_CHR(10), 1));
/*195*/ 	if( bnf_chk_do_print_html ){
/*196*/ 		m2_print((STRING *) "\0\0\0\0\4\0\0\000</b>");
/*199*/ 	}
/*209*/ }


/*211*/ void
/*211*/ bnf_chk_warning(STRING *bnf_chk_s)
/*211*/ {
/*211*/ 	bnf_chk_message((STRING *) "\0\0\0\0\7\0\0\000Warning", bnf_chk_s);
/*215*/ }


/*217*/ void
/*217*/ bnf_chk_err(STRING *bnf_chk_s)
/*217*/ {
/*217*/ 	bnf_chk_message((STRING *) "\0\0\0\0\5\0\0\000ERROR", bnf_chk_s);
/*221*/ }


/*223*/ void
/*223*/ bnf_chk_fatal(STRING *bnf_chk_s)
/*223*/ {
/*223*/ 	bnf_chk_message((STRING *) "\0\0\0\0\5\0\0\000FATAL", bnf_chk_s);
/*224*/ 	m2runtime_exit(1);
/*228*/ }


/*230*/ STRING *
/*230*/ bnf_chk_read_lit_string(void)
/*230*/ {

/*232*/ 	int
/*232*/ 	bnf_chk_hex(STRING *bnf_chk_c)
/*232*/ 	{
/*232*/ 		if( ((m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(48)) >= 0) && (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(57)) <= 0)) ){
/*233*/ 			return m2_stoi(bnf_chk_c);
/*234*/ 		} else if( ((m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(65)) >= 0) && (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(70)) <= 0)) ){
/*235*/ 			return ((m2runtime_ASC(bnf_chk_c) - m2runtime_ASC(m2runtime_CHR(65))) + 10);
/*236*/ 		} else if( ((m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(97)) >= 0) && (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(102)) <= 0)) ){
/*237*/ 			return ((m2runtime_ASC(bnf_chk_c) - m2runtime_ASC(m2runtime_CHR(97))) + 10);
/*239*/ 		} else {
/*239*/ 			bnf_chk_fatal(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\33\0\0\000invalid hexadecimal digit `", bnf_chk_c, m2runtime_CHR(39), 1));
/*242*/ 		}
/*242*/ 		m2runtime_missing_return(bnf_chk_0err_entry_get, 3);
/*242*/ 		return 0;
/*243*/ 	}

/*243*/ 	STRING * bnf_chk_s = NULL;
/*245*/ 	int bnf_chk_d2 = 0;
/*245*/ 	int bnf_chk_d1 = 0;
/*245*/ 	bnf_chk_s = m2runtime_CHR(34);
/*246*/ 	bnf_chk_read_ch();
/*248*/ 	do{
/*248*/ 		if( bnf_chk_c == NULL ){
/*249*/ 			bnf_chk_fatal((STRING *) "\0\0\0\0\27\0\0\000unclosed literal string");
/*251*/ 		} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(34)) == 0 ){
/*252*/ 			bnf_chk_read_ch();
/*253*/ 			if( (m2runtime_length(bnf_chk_s) == 1) ){
/*254*/ 				bnf_chk_fatal((STRING *) "\0\0\0\0\24\0\0\000invalid empty string");
/*256*/ 			}
/*256*/ 			return m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(34), 1);
/*258*/ 		} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(92)) == 0 ){
/*259*/ 			bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(92), 1);
/*260*/ 			bnf_chk_read_ch();
/*261*/ 			if( ((m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(34)) == 0) || (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(92)) == 0)) ){
/*262*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, bnf_chk_c, 1);
/*263*/ 				bnf_chk_read_ch();
/*264*/ 			} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(97)) == 0 ){
/*265*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(97), 1);
/*266*/ 				bnf_chk_read_ch();
/*267*/ 			} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(98)) == 0 ){
/*268*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(98), 1);
/*269*/ 				bnf_chk_read_ch();
/*270*/ 			} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(110)) == 0 ){
/*271*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(110), 1);
/*272*/ 				bnf_chk_read_ch();
/*273*/ 			} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(114)) == 0 ){
/*274*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(114), 1);
/*275*/ 				bnf_chk_read_ch();
/*276*/ 			} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(116)) == 0 ){
/*277*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(116), 1);
/*278*/ 				bnf_chk_read_ch();
/*279*/ 			} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(120)) == 0 ){
/*280*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(120), 1);
/*281*/ 				bnf_chk_read_ch();
/*282*/ 				bnf_chk_d1 = bnf_chk_hex(bnf_chk_c);
/*283*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, bnf_chk_c, 1);
/*284*/ 				bnf_chk_read_ch();
/*285*/ 				bnf_chk_d2 = bnf_chk_hex(bnf_chk_c);
/*286*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, bnf_chk_c, 1);
/*287*/ 				bnf_chk_read_ch();
/*290*/ 			} else {
/*290*/ 				bnf_chk_fatal(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\32\0\0\000invalid escape sequence \042\134", bnf_chk_c, m2runtime_CHR(34), 1));
/*293*/ 			}
/*293*/ 		} else if( ((m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(32)) >= 0) && ((m2runtime_ASC(bnf_chk_c) != 127))) ){
/*294*/ 			bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, bnf_chk_c, 1);
/*295*/ 			bnf_chk_read_ch();
/*298*/ 		} else {
/*298*/ 			bnf_chk_err(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\37\0\0\000invalid control character code ", m2runtime_itos(m2runtime_ASC(bnf_chk_c)), (STRING *) "\0\0\0\0\56\0\0\000 in literal string -- possible unclosed string", 1));
/*299*/ 			bnf_chk_read_ch();
/*300*/ 			return m2runtime_concat_STRING(0, bnf_chk_s, m2runtime_CHR(34), 1);
/*304*/ 		}
/*305*/ 	}while(1);
/*305*/ 	m2runtime_missing_return(bnf_chk_0err_entry_get, 4);
/*305*/ 	return NULL;
/*307*/ }


/*309*/ void
/*309*/ bnf_chk_read_sym(void)
/*309*/ {

/*311*/ 	void
/*311*/ 	bnf_chk_WarnInvalidEq(STRING *bnf_chk_s)
/*311*/ 	{
/*311*/ 		if( !bnf_chk_warn_invalid_eq ){
/*312*/ 			bnf_chk_warn_invalid_eq = TRUE;
/*313*/ 			bnf_chk_warning(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\11\0\0\000invalid `", bnf_chk_s, (STRING *) "\0\0\0\0\42\0\0\000' symbol -- please use `=' instead", 1));
/*316*/ 		}
/*318*/ 	}

/*318*/ 	while( ((m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(32)) == 0) || (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(9)) == 0) || (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(35)) == 0) || (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(10)) == 0) || (m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(13)) == 0)) ){
/*319*/ 		if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(35)) == 0 ){
/*321*/ 			do{
/*321*/ 				bnf_chk_read_ch();
/*322*/ 				if( ((m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(10)) == 0) || (bnf_chk_c == NULL)) ){
/*325*/ 					goto m2runtime_loop_1;
/*326*/ 				}
/*327*/ 			}while(1);
m2runtime_loop_1: ;
/*327*/ 		} else {
/*327*/ 			bnf_chk_read_ch();
/*330*/ 		}
/*330*/ 	}
/*330*/ 	if( bnf_chk_c == NULL ){
/*331*/ 		bnf_chk_sym = 0;
/*332*/ 	} else if( m2_match(bnf_chk_c, (STRING *) "\0\0\0\0\11\0\0\000[a-zA-Z_]") ){
/*333*/ 		bnf_chk_s = bnf_chk_c;
/*335*/ 		do{
/*335*/ 			bnf_chk_read_ch();
/*336*/ 			if( m2_match(bnf_chk_c, (STRING *) "\0\0\0\0\14\0\0\000[a-zA-Z0-9_]") ){
/*337*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, bnf_chk_c, 1);
/*340*/ 			} else {
/*341*/ 				goto m2runtime_loop_2;
/*342*/ 			}
/*342*/ 		}while(1);
m2runtime_loop_2: ;
/*342*/ 		if( bnf_chk_warn_invalid_id ){
/*343*/ 			if( !bnf_chk_warn_invalid_unquoted_lit_str ){
/*344*/ 				bnf_chk_warn_invalid_unquoted_lit_str = TRUE;
/*345*/ 				bnf_chk_warning((STRING *) "\0\0\0\0\152\0\0\000guessed usage of the syntax style <ID> for IDs and STRING for literal strings -- trying to continue anyway");
/*347*/ 			}
/*347*/ 			bnf_chk_s = m2runtime_concat_STRING(0, m2runtime_CHR(34), bnf_chk_s, m2runtime_CHR(34), 1);
/*348*/ 			bnf_chk_sym = 11;
/*350*/ 		} else {
/*350*/ 			bnf_chk_sym = 2;
/*352*/ 		}
/*352*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(60)) == 0 ){
/*353*/ 		bnf_chk_s = EMPTY_STRING;
/*355*/ 		do{
/*355*/ 			bnf_chk_read_ch();
/*356*/ 			if( m2_match(bnf_chk_c, (STRING *) "\0\0\0\0\17\0\0\000[\134-a-zA-Z0-9_ ]") ){
/*357*/ 				if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(32)) == 0 ){
/*358*/ 					bnf_chk_c = m2runtime_CHR(95);
/*359*/ 				} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(45)) == 0 ){
/*360*/ 					bnf_chk_c = m2runtime_CHR(95);
/*362*/ 				}
/*362*/ 				bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, bnf_chk_c, 1);
/*363*/ 			} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(62)) == 0 ){
/*364*/ 				if( !bnf_chk_warn_invalid_id ){
/*365*/ 					bnf_chk_warn_invalid_id = TRUE;
/*366*/ 					bnf_chk_warning((STRING *) "\0\0\0\0\105\0\0\000invalid identifier syntax `<SOME ID>' -- please use `SOME_ID' instead");
/*368*/ 				}
/*368*/ 				bnf_chk_read_ch();
/*371*/ 				goto m2runtime_loop_3;
/*371*/ 			} else {
/*371*/ 				bnf_chk_fatal((STRING *) "\0\0\0\0\34\0\0\000invalid char in <identifier>");
/*374*/ 			}
/*374*/ 		}while(1);
m2runtime_loop_3: ;
/*374*/ 		bnf_chk_sym = 2;
/*375*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(61)) == 0 ){
/*376*/ 		bnf_chk_sym = 3;
/*377*/ 		bnf_chk_read_ch();
/*378*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(58)) == 0 ){
/*379*/ 		bnf_chk_read_ch();
/*380*/ 		if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(61)) == 0 ){
/*381*/ 			bnf_chk_WarnInvalidEq((STRING *) "\0\0\0\0\2\0\0\000:=");
/*382*/ 			bnf_chk_read_ch();
/*383*/ 			bnf_chk_sym = 3;
/*384*/ 		} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(58)) == 0 ){
/*385*/ 			bnf_chk_read_ch();
/*386*/ 			if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(61)) == 0 ){
/*387*/ 				bnf_chk_WarnInvalidEq((STRING *) "\0\0\0\0\3\0\0\000::=");
/*388*/ 				bnf_chk_read_ch();
/*389*/ 				bnf_chk_sym = 3;
/*391*/ 			} else {
/*391*/ 				bnf_chk_fatal((STRING *) "\0\0\0\0\33\0\0\000invalid character or symbol");
/*394*/ 			}
/*394*/ 		} else {
/*394*/ 			bnf_chk_fatal((STRING *) "\0\0\0\0\33\0\0\000invalid character or symbol");
/*396*/ 		}
/*396*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(124)) == 0 ){
/*397*/ 		bnf_chk_sym = 10;
/*398*/ 		bnf_chk_read_ch();
/*399*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(123)) == 0 ){
/*400*/ 		bnf_chk_sym = 4;
/*401*/ 		bnf_chk_read_ch();
/*402*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(125)) == 0 ){
/*403*/ 		bnf_chk_sym = 5;
/*404*/ 		bnf_chk_read_ch();
/*405*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(91)) == 0 ){
/*406*/ 		bnf_chk_sym = 6;
/*407*/ 		bnf_chk_read_ch();
/*408*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(93)) == 0 ){
/*409*/ 		bnf_chk_sym = 7;
/*410*/ 		bnf_chk_read_ch();
/*411*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(40)) == 0 ){
/*412*/ 		bnf_chk_sym = 8;
/*413*/ 		bnf_chk_read_ch();
/*414*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(41)) == 0 ){
/*415*/ 		bnf_chk_sym = 9;
/*416*/ 		bnf_chk_read_ch();
/*417*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(59)) == 0 ){
/*418*/ 		bnf_chk_sym = 1;
/*419*/ 		bnf_chk_read_ch();
/*420*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(34)) == 0 ){
/*421*/ 		bnf_chk_s = bnf_chk_read_lit_string();
/*422*/ 		bnf_chk_sym = 11;
/*423*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(46)) == 0 ){
/*424*/ 		bnf_chk_read_ch();
/*425*/ 		if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(46)) == 0 ){
/*426*/ 			bnf_chk_read_ch();
/*427*/ 			bnf_chk_sym = 12;
/*429*/ 		} else {
/*429*/ 			if( !bnf_chk_warn_invalid_rule_terminator ){
/*430*/ 				bnf_chk_warn_invalid_rule_terminator = TRUE;
/*431*/ 				bnf_chk_warning((STRING *) "\0\0\0\0\65\0\0\000invalid rule terminator `.' -- please use `;' instead");
/*433*/ 			}
/*433*/ 			bnf_chk_sym = 1;
/*434*/ 			bnf_chk_read_ch();
/*436*/ 		}
/*436*/ 	} else if( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(32)) > 0 ){
/*437*/ 		bnf_chk_err(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\26\0\0\000unexpected character `", bnf_chk_c, (STRING *) "\0\0\0\0\36\0\0\000' -- trying to continue anyway", 1));
/*438*/ 		bnf_chk_s = bnf_chk_c;
/*439*/ 		bnf_chk_read_ch();
/*440*/ 		while( m2runtime_strcmp(bnf_chk_c, m2runtime_CHR(32)) > 0 ){
/*441*/ 			bnf_chk_s = m2runtime_concat_STRING(0, bnf_chk_s, bnf_chk_c, 1);
/*442*/ 			bnf_chk_read_ch();
/*444*/ 		}
/*444*/ 		bnf_chk_s = m2runtime_concat_STRING(0, m2runtime_CHR(34), bnf_chk_s, m2runtime_CHR(34), 1);
/*445*/ 		bnf_chk_sym = 11;
/*447*/ 	} else {
/*447*/ 		bnf_chk_err((STRING *) "\0\0\0\0\64\0\0\000unexpected control char -- trying to continue anyway");
/*448*/ 		bnf_chk_sym = 11;
/*451*/ 	}
/*453*/ }


/*455*/ RECORD *
/*455*/ bnf_chk_add_id(STRING *bnf_chk_name, int bnf_chk_decl)
/*455*/ {
/*456*/ 	int bnf_chk_i = 0;
/*458*/ 	RECORD * bnf_chk_id = NULL;
/*458*/ 	{
/*458*/ 		int m2runtime_for_limit_1;
/*458*/ 		bnf_chk_i = 0;
/*458*/ 		m2runtime_for_limit_1 = (m2runtime_count(bnf_chk_ids) - 1);
/*459*/ 		for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*459*/ 			if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_ids, bnf_chk_i, bnf_chk_0err_entry_get, 5), 8, bnf_chk_0err_entry_get, 6), bnf_chk_name) == 0 ){
/*460*/ 				bnf_chk_id = (RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_ids, bnf_chk_i, bnf_chk_0err_entry_get, 7);
/*463*/ 			}
/*463*/ 		}
/*463*/ 	}
/*463*/ 	if( bnf_chk_id == NULL ){
/*464*/ 		if( bnf_chk_decl ){
/*465*/ 			*(STRING **)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 8, bnf_chk_0err_entry_get, 8) = bnf_chk_name;
/*466*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 12, bnf_chk_0err_entry_get, 9) = TRUE;
/*467*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 16, bnf_chk_0err_entry_get, 10) = bnf_chk_line_n;
/*468*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 24, bnf_chk_0err_entry_get, 11) = 0;
/*470*/ 		} else {
/*470*/ 			*(STRING **)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 8, bnf_chk_0err_entry_get, 12) = bnf_chk_name;
/*471*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 12, bnf_chk_0err_entry_get, 13) = FALSE;
/*472*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 16, bnf_chk_0err_entry_get, 14) = 0;
/*473*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 24, bnf_chk_0err_entry_get, 15) = ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 24, bnf_chk_0err_entry_get, 16) + 1);
/*475*/ 		}
/*475*/ 		*(RECORD **)m2runtime_dereference_lhs_ARRAY(&bnf_chk_ids, 4, 1, m2runtime_count(bnf_chk_ids), bnf_chk_0err_entry_get, 17) = bnf_chk_id;
/*477*/ 	} else {
/*477*/ 		if( bnf_chk_decl ){
/*478*/ 			if(  *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 12, bnf_chk_0err_entry_get, 18) ){
/*479*/ 				bnf_chk_fatal(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\4\0\0\000id `", bnf_chk_name, (STRING *) "\0\0\0\0\32\0\0\000' already defined in line ", m2runtime_itos( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 16, bnf_chk_0err_entry_get, 19)), 1));
/*483*/ 			} else {
/*483*/ 				*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 12, bnf_chk_0err_entry_get, 20) = TRUE;
/*484*/ 				*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 16, bnf_chk_0err_entry_get, 21) = bnf_chk_line_n;
/*487*/ 			}
/*487*/ 		} else {
/*487*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_id, 28, 1, 24, bnf_chk_0err_entry_get, 22) = ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 24, bnf_chk_0err_entry_get, 23) + 1);
/*490*/ 		}
/*490*/ 	}
/*490*/ 	return bnf_chk_id;
/*494*/ }


/*495*/ void
/*495*/ bnf_chk_ids_report(void)
/*495*/ {
/*495*/ 	int bnf_chk_i = 0;
/*497*/ 	RECORD * bnf_chk_id = NULL;
/*497*/ 	bnf_chk_print_text((STRING *) "\0\0\0\0\14\0\0\000IDs report:\012");
/*498*/ 	{
/*498*/ 		int m2runtime_for_limit_1;
/*498*/ 		bnf_chk_i = 0;
/*498*/ 		m2runtime_for_limit_1 = (m2runtime_count(bnf_chk_ids) - 1);
/*499*/ 		for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*499*/ 			bnf_chk_id = (RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_ids, bnf_chk_i, bnf_chk_0err_entry_get, 24);
/*500*/ 			if( (! *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 12, bnf_chk_0err_entry_get, 25) || (( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 24, bnf_chk_0err_entry_get, 26) == 0))) ){
/*501*/ 				bnf_chk_print_text(m2runtime_concat_STRING(0, (STRING *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 8, bnf_chk_0err_entry_get, 27), (STRING *) "\0\0\0\0\2\0\0\000: ", 1));
/*502*/ 				if(  *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 12, bnf_chk_0err_entry_get, 28) ){
/*503*/ 					bnf_chk_print_text(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\20\0\0\000defined in line ", m2runtime_itos( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 16, bnf_chk_0err_entry_get, 29)), (STRING *) "\0\0\0\0\2\0\0\000, ", 1));
/*505*/ 				} else {
/*505*/ 					bnf_chk_print_text((STRING *) "\0\0\0\0\15\0\0\000NOT DEFINED, ");
/*507*/ 				}
/*507*/ 				if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 24, bnf_chk_0err_entry_get, 30) > 0) ){
/*508*/ 					bnf_chk_print_text(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\5\0\0\000used ", m2runtime_itos( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_id, 24, bnf_chk_0err_entry_get, 31)), (STRING *) "\0\0\0\0\7\0\0\000 times\012", 1));
/*510*/ 				} else {
/*510*/ 					bnf_chk_print_text((STRING *) "\0\0\0\0\11\0\0\000NOT USED\012");
/*513*/ 				}
/*514*/ 			}
/*515*/ 		}
/*515*/ 	}
/*522*/ }


/*525*/ RECORD *
/*525*/ bnf_chk_read_expr(void)
/*525*/ {

/*526*/ 	RECORD *
/*526*/ 	bnf_chk_read_factor(void)
/*526*/ 	{
/*528*/ 		RECORD * bnf_chk_f = NULL;
/*528*/ 		if( (bnf_chk_sym == 8) ){
/*529*/ 			bnf_chk_read_sym();
/*530*/ 			bnf_chk_f = bnf_chk_read_expr();
/*531*/ 			if( (bnf_chk_sym != 9) ){
/*532*/ 				bnf_chk_fatal((STRING *) "\0\0\0\0\14\0\0\000expected `)'");
/*534*/ 			}
/*534*/ 			bnf_chk_read_sym();
/*535*/ 		} else if( (bnf_chk_sym == 6) ){
/*536*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 24, bnf_chk_0err_entry_get, 32) = 5;
/*537*/ 			bnf_chk_read_sym();
/*538*/ 			*(RECORD **)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 16, bnf_chk_0err_entry_get, 33) = bnf_chk_read_expr();
/*539*/ 			if( (bnf_chk_sym != 7) ){
/*540*/ 				bnf_chk_fatal((STRING *) "\0\0\0\0\14\0\0\000expected `]'");
/*542*/ 			}
/*542*/ 			bnf_chk_read_sym();
/*543*/ 		} else if( (bnf_chk_sym == 4) ){
/*544*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 24, bnf_chk_0err_entry_get, 34) = 4;
/*545*/ 			bnf_chk_read_sym();
/*546*/ 			*(RECORD **)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 16, bnf_chk_0err_entry_get, 35) = bnf_chk_read_expr();
/*547*/ 			if( (bnf_chk_sym != 5) ){
/*548*/ 				bnf_chk_fatal((STRING *) "\0\0\0\0\14\0\0\000expected `}'");
/*550*/ 			}
/*550*/ 			bnf_chk_read_sym();
/*551*/ 		} else if( (bnf_chk_sym == 2) ){
/*552*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 24, bnf_chk_0err_entry_get, 36) = 0;
/*553*/ 			*(RECORD **)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 8, bnf_chk_0err_entry_get, 37) = bnf_chk_add_id(bnf_chk_s, FALSE);
/*554*/ 			bnf_chk_read_sym();
/*555*/ 		} else if( (bnf_chk_sym == 11) ){
/*556*/ 			*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 24, bnf_chk_0err_entry_get, 38) = 1;
/*558*/ 			*(STRING **)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 12, bnf_chk_0err_entry_get, 39) = bnf_chk_s;
/*559*/ 			bnf_chk_read_sym();
/*560*/ 			if( (bnf_chk_sym == 12) ){
/*561*/ 				bnf_chk_read_sym();
/*562*/ 				if( (bnf_chk_sym != 11) ){
/*563*/ 					bnf_chk_fatal((STRING *) "\0\0\0\0\45\0\0\000expected string after range separator");
/*566*/ 				}
/*566*/ 				*(STRING **)m2runtime_dereference_lhs_RECORD(&bnf_chk_f, 28, 4, 12, bnf_chk_0err_entry_get, 40) = m2runtime_concat_STRING(0, (STRING *)m2runtime_dereference_rhs_RECORD(bnf_chk_f, 12, bnf_chk_0err_entry_get, 41), (STRING *) "\0\0\0\0\2\0\0\000..", bnf_chk_s, 1);
/*567*/ 				bnf_chk_read_sym();
/*570*/ 			}
/*570*/ 		} else {
/*570*/ 			return NULL;
/*572*/ 		}
/*572*/ 		return bnf_chk_f;
/*576*/ 	}


/*577*/ 	RECORD *
/*577*/ 	bnf_chk_read_termin(void)
/*577*/ 	{
/*579*/ 		RECORD * bnf_chk_p = NULL;
/*579*/ 		RECORD * bnf_chk_p2 = NULL;
/*579*/ 		RECORD * bnf_chk_f = NULL;
/*580*/ 		bnf_chk_p = bnf_chk_read_factor();
/*581*/ 		if( bnf_chk_p == NULL ){
/*582*/ 			bnf_chk_fatal((STRING *) "\0\0\0\0\17\0\0\000expected factor");
/*585*/ 		}
/*585*/ 		bnf_chk_f = bnf_chk_read_factor();
/*586*/ 		if( bnf_chk_f == NULL ){
/*587*/ 			return bnf_chk_p;
/*589*/ 		}
/*589*/ 		*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_p2, 28, 4, 24, bnf_chk_0err_entry_get, 42) = 2;
/*590*/ 		*(RECORD **)m2runtime_dereference_lhs_ARRAY((ARRAY **)m2runtime_dereference_lhs_RECORD(&bnf_chk_p2, 28, 4, 20, bnf_chk_0err_entry_get, 43), 4, 1, 0, bnf_chk_0err_entry_get, 44) = bnf_chk_p;
/*591*/ 		*(RECORD **)m2runtime_dereference_lhs_ARRAY((ARRAY **)m2runtime_dereference_lhs_RECORD(&bnf_chk_p2, 28, 4, 20, bnf_chk_0err_entry_get, 45), 4, 1, 1, bnf_chk_0err_entry_get, 46) = bnf_chk_f;
/*592*/ 		bnf_chk_p = bnf_chk_p2;
/*595*/ 		do{
/*595*/ 			bnf_chk_f = bnf_chk_read_factor();
/*596*/ 			if( bnf_chk_f == NULL ){
/*597*/ 				return bnf_chk_p;
/*599*/ 			}
/*599*/ 			*(RECORD **)m2runtime_dereference_lhs_ARRAY((ARRAY **)m2runtime_dereference_lhs_RECORD(&bnf_chk_p, 28, 4, 20, bnf_chk_0err_entry_get, 47), 4, 1, m2runtime_count((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_p, 20, bnf_chk_0err_entry_get, 48)), bnf_chk_0err_entry_get, 49) = bnf_chk_f;
/*602*/ 		}while(1);
/*602*/ 		m2runtime_missing_return(bnf_chk_0err_entry_get, 50);
/*602*/ 		return NULL;
/*603*/ 	}

/*606*/ 	RECORD * bnf_chk_s = NULL;
/*606*/ 	RECORD * bnf_chk_e = NULL;
/*606*/ 	bnf_chk_e = bnf_chk_read_termin();
/*607*/ 	if( (bnf_chk_sym == 10) ){
/*608*/ 		*(int *)m2runtime_dereference_lhs_RECORD(&bnf_chk_s, 28, 4, 24, bnf_chk_0err_entry_get, 51) = 3;
/*609*/ 		*(RECORD **)m2runtime_dereference_lhs_ARRAY((ARRAY **)m2runtime_dereference_lhs_RECORD(&bnf_chk_s, 28, 4, 20, bnf_chk_0err_entry_get, 52), 4, 1, 0, bnf_chk_0err_entry_get, 53) = bnf_chk_e;
/*610*/ 		bnf_chk_e = bnf_chk_s;
/*612*/ 	}
/*612*/ 	while( (bnf_chk_sym == 10) ){
/*613*/ 		bnf_chk_read_sym();
/*614*/ 		*(RECORD **)m2runtime_dereference_lhs_ARRAY((ARRAY **)m2runtime_dereference_lhs_RECORD(&bnf_chk_e, 28, 4, 20, bnf_chk_0err_entry_get, 54), 4, 1, m2runtime_count((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_e, 20, bnf_chk_0err_entry_get, 55)), bnf_chk_0err_entry_get, 56) = bnf_chk_read_termin();
/*616*/ 	}
/*616*/ 	return bnf_chk_e;
/*620*/ }


/*621*/ RECORD *
/*621*/ bnf_chk_read_decl(void)
/*621*/ {
/*623*/ 	RECORD * bnf_chk_d = NULL;
/*623*/ 	if( (bnf_chk_sym != 2) ){
/*624*/ 		bnf_chk_fatal((STRING *) "\0\0\0\0\22\0\0\000expected rule name");
/*626*/ 	}
/*626*/ 	*(RECORD **)m2runtime_dereference_lhs_RECORD(&bnf_chk_d, 16, 2, 8, bnf_chk_0err_entry_get, 57) = bnf_chk_add_id(bnf_chk_s, TRUE);
/*627*/ 	bnf_chk_read_sym();
/*628*/ 	if( (bnf_chk_sym != 3) ){
/*629*/ 		bnf_chk_fatal((STRING *) "\0\0\0\0\14\0\0\000expected `='");
/*631*/ 	}
/*631*/ 	bnf_chk_read_sym();
/*632*/ 	*(RECORD **)m2runtime_dereference_lhs_RECORD(&bnf_chk_d, 16, 2, 12, bnf_chk_0err_entry_get, 58) = bnf_chk_read_expr();
/*633*/ 	if( (bnf_chk_sym != 1) ){
/*634*/ 		bnf_chk_err((STRING *) "\0\0\0\0\101\0\0\000unexpected symbol -- check possible missing `;' in the rule above");
/*636*/ 	}
/*636*/ 	bnf_chk_read_sym();
/*637*/ 	return bnf_chk_d;
/*641*/ }


/*643*/ void
/*643*/ bnf_chk_read_decls(STRING *bnf_chk_fn)
/*643*/ {
/*644*/ 	int bnf_chk_index = 0;
/*646*/ 	RECORD * bnf_chk_decl = NULL;
/*646*/ 	m2runtime_ERROR_CODE = 0;
/*646*/ 	io_Open(1, (void *)&bnf_chk_fd, bnf_chk_fn, m2runtime_CHR(114));
/*647*/ 	switch( m2runtime_ERROR_CODE ){

/*647*/ 	case 0:  break;
/*647*/ 	default:
/*647*/ 		m2runtime_HALT(bnf_chk_0err_entry_get, 59, m2runtime_ERROR_MESSAGE);
/*647*/ 	}
/*647*/ 	bnf_chk_line_n = 1;
/*648*/ 	bnf_chk_line_pos = 0;
/*649*/ 	m2runtime_ERROR_CODE = 0;
/*649*/ 	bnf_chk_line = io_ReadLine(1, bnf_chk_fd);
/*650*/ 	switch( m2runtime_ERROR_CODE ){

/*650*/ 	case 0:  break;
/*650*/ 	default:
/*650*/ 		m2runtime_HALT(bnf_chk_0err_entry_get, 60, m2runtime_ERROR_MESSAGE);
/*650*/ 	}
/*650*/ 	bnf_chk_c = NULL;
/*651*/ 	if( bnf_chk_print_source ){
/*652*/ 		bnf_chk_PrintLineSource();
/*654*/ 	}
/*654*/ 	bnf_chk_read_ch();
/*655*/ 	bnf_chk_read_sym();
/*656*/ 	while( (bnf_chk_sym != 0) ){
/*657*/ 		bnf_chk_decl = bnf_chk_read_decl();
/*658*/ 		m2_inc(&bnf_chk_index, 1);
/*659*/ 		*(int *)m2runtime_dereference_lhs_RECORD((RECORD **)m2runtime_dereference_lhs_RECORD(&bnf_chk_decl, 16, 2, 8, bnf_chk_0err_entry_get, 61), 28, 1, 20, bnf_chk_0err_entry_get, 62) = bnf_chk_index;
/*660*/ 		*(RECORD **)m2runtime_dereference_lhs_ARRAY(&bnf_chk_decls, 4, 1, m2runtime_count(bnf_chk_decls), bnf_chk_0err_entry_get, 63) = bnf_chk_decl;
/*663*/ 	}
/*665*/ }


/*666*/ void
/*666*/ bnf_chk_sort_decls(ARRAY *bnf_chk_decls)
/*666*/ {
/*666*/ 	int bnf_chk_j = 0;
/*666*/ 	int bnf_chk_i = 0;
/*668*/ 	RECORD * bnf_chk_d = NULL;
/*668*/ 	{
/*668*/ 		int m2runtime_for_limit_1;
/*668*/ 		bnf_chk_i = 0;
/*668*/ 		m2runtime_for_limit_1 = (m2runtime_count(bnf_chk_decls) - 2);
/*669*/ 		for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*669*/ 			{
/*669*/ 				int m2runtime_for_limit_2;
/*669*/ 				bnf_chk_j = (bnf_chk_i + 1);
/*669*/ 				m2runtime_for_limit_2 = (m2runtime_count(bnf_chk_decls) - 1);
/*670*/ 				for( ; bnf_chk_j <= m2runtime_for_limit_2; bnf_chk_j += 1 ){
/*670*/ 					if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_decls, bnf_chk_i, bnf_chk_0err_entry_get, 64), 8, bnf_chk_0err_entry_get, 65), 8, bnf_chk_0err_entry_get, 66), (STRING *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_decls, bnf_chk_j, bnf_chk_0err_entry_get, 67), 8, bnf_chk_0err_entry_get, 68), 8, bnf_chk_0err_entry_get, 69)) > 0 ){
/*671*/ 						bnf_chk_d = (RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_decls, bnf_chk_i, bnf_chk_0err_entry_get, 70);
/*672*/ 						*(RECORD **)m2runtime_dereference_lhs_ARRAY(&bnf_chk_decls, 4, 1, bnf_chk_i, bnf_chk_0err_entry_get, 71) = (RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_decls, bnf_chk_j, bnf_chk_0err_entry_get, 72);
/*673*/ 						*(RECORD **)m2runtime_dereference_lhs_ARRAY(&bnf_chk_decls, 4, 1, bnf_chk_j, bnf_chk_0err_entry_get, 73) = bnf_chk_d;
/*676*/ 					}
/*676*/ 				}
/*676*/ 			}
/*676*/ 			*(int *)m2runtime_dereference_lhs_RECORD((RECORD **)m2runtime_dereference_lhs_RECORD((RECORD **)m2runtime_dereference_lhs_ARRAY(&bnf_chk_decls, 4, 1, bnf_chk_i, bnf_chk_0err_entry_get, 74), 16, 2, 8, bnf_chk_0err_entry_get, 75), 28, 1, 20, bnf_chk_0err_entry_get, 76) = (bnf_chk_i + 1);
/*679*/ 		}
/*679*/ 	}
/*681*/ }


/*683*/ void
/*683*/ bnf_chk_print_as_text(ARRAY *bnf_chk_decls)
/*683*/ {

/*684*/ 	void
/*684*/ 	bnf_chk_print_expr(RECORD *bnf_chk_d)
/*684*/ 	{
/*686*/ 		int bnf_chk_index = 0;
/*686*/ 		int bnf_chk_i = 0;
/*686*/ 		if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 77) == 0) ){
/*687*/ 			bnf_chk_print_text(m2runtime_concat_STRING(0, m2runtime_CHR(32), (STRING *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 8, bnf_chk_0err_entry_get, 78), 8, bnf_chk_0err_entry_get, 79), 1));
/*688*/ 			if( bnf_chk_do_print_index ){
/*689*/ 				bnf_chk_index =  *(int *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 8, bnf_chk_0err_entry_get, 80), 20, bnf_chk_0err_entry_get, 81);
/*690*/ 				if( (bnf_chk_index == 0) ){
/*691*/ 					m2_print((STRING *) "\0\0\0\0\2\0\0\000_?");
/*693*/ 				} else {
/*693*/ 					m2_print(m2runtime_concat_STRING(0, m2runtime_CHR(95), m2runtime_itos(bnf_chk_index), 1));
/*696*/ 				}
/*696*/ 			}
/*696*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 82) == 1) ){
/*697*/ 			m2_print(m2runtime_concat_STRING(0, m2runtime_CHR(32), (STRING *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 12, bnf_chk_0err_entry_get, 83), 1));
/*698*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 84) == 4) ){
/*699*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 {");
/*700*/ 			bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 16, bnf_chk_0err_entry_get, 85));
/*701*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 }");
/*702*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 86) == 5) ){
/*703*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 [");
/*704*/ 			bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 16, bnf_chk_0err_entry_get, 87));
/*705*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 ]");
/*706*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 88) == 2) ){
/*707*/ 			{
/*707*/ 				int m2runtime_for_limit_1;
/*707*/ 				bnf_chk_i = 0;
/*707*/ 				m2runtime_for_limit_1 = (m2runtime_count((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 89)) - 1);
/*708*/ 				for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*708*/ 					if( ( *(int *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 90), bnf_chk_i, bnf_chk_0err_entry_get, 91), 24, bnf_chk_0err_entry_get, 92) == 3) ){
/*709*/ 						m2_print((STRING *) "\0\0\0\0\2\0\0\000 (");
/*710*/ 						bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 93), bnf_chk_i, bnf_chk_0err_entry_get, 94));
/*711*/ 						m2_print((STRING *) "\0\0\0\0\2\0\0\000 )");
/*713*/ 					} else {
/*713*/ 						bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 95), bnf_chk_i, bnf_chk_0err_entry_get, 96));
/*716*/ 					}
/*716*/ 				}
/*716*/ 			}
/*716*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 97) == 3) ){
/*717*/ 			{
/*717*/ 				int m2runtime_for_limit_1;
/*717*/ 				bnf_chk_i = 0;
/*717*/ 				m2runtime_for_limit_1 = (m2runtime_count((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 98)) - 1);
/*718*/ 				for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*718*/ 					if( (bnf_chk_i > 0) ){
/*719*/ 						m2_print((STRING *) "\0\0\0\0\2\0\0\000 |");
/*721*/ 					}
/*721*/ 					bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 99), bnf_chk_i, bnf_chk_0err_entry_get, 100));
/*724*/ 				}
/*724*/ 			}
/*724*/ 		} else {
/*724*/ 			m2_error((STRING *) "\0\0\0\0\23\0\0\000internal error (1)\012");
/*725*/ 			m2runtime_exit(1);
/*728*/ 		}
/*729*/ 	}

/*729*/ 	int bnf_chk_i = 0;
/*731*/ 	RECORD * bnf_chk_d = NULL;
/*731*/ 	{
/*731*/ 		int m2runtime_for_limit_1;
/*731*/ 		bnf_chk_i = 0;
/*731*/ 		m2runtime_for_limit_1 = (m2runtime_count(bnf_chk_decls) - 1);
/*732*/ 		for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*732*/ 			if( bnf_chk_do_print_index ){
/*733*/ 				m2_print(m2runtime_concat_STRING(0, m2runtime_itos((bnf_chk_i + 1)), (STRING *) "\0\0\0\0\2\0\0\000. ", 1));
/*735*/ 			}
/*735*/ 			bnf_chk_d = (RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_decls, bnf_chk_i, bnf_chk_0err_entry_get, 101);
/*736*/ 			m2_print((STRING *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 8, bnf_chk_0err_entry_get, 102), 8, bnf_chk_0err_entry_get, 103));
/*737*/ 			m2_print((STRING *) "\0\0\0\0\3\0\0\000 = ");
/*738*/ 			bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 12, bnf_chk_0err_entry_get, 104));
/*739*/ 			bnf_chk_print_text((STRING *) "\0\0\0\0\3\0\0\000 ;\012");
/*742*/ 		}
/*742*/ 	}
/*744*/ }


/*746*/ void
/*746*/ bnf_chk_print_as_html(ARRAY *bnf_chk_decls)
/*746*/ {

/*747*/ 	void
/*747*/ 	bnf_chk_print_expr(RECORD *bnf_chk_d)
/*747*/ 	{
/*749*/ 		int bnf_chk_index = 0;
/*749*/ 		int bnf_chk_i = 0;
/*749*/ 		if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 105) == 0) ){
/*750*/ 			m2_print(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\4\0\0\000 <i>", (STRING *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 8, bnf_chk_0err_entry_get, 106), 8, bnf_chk_0err_entry_get, 107), (STRING *) "\0\0\0\0\4\0\0\000</i>", 1));
/*751*/ 			if( bnf_chk_do_print_index ){
/*752*/ 				bnf_chk_index =  *(int *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 8, bnf_chk_0err_entry_get, 108), 20, bnf_chk_0err_entry_get, 109);
/*753*/ 				if( (bnf_chk_index == 0) ){
/*754*/ 					m2_print((STRING *) "\0\0\0\0\14\0\0\000<sub>?</sub>");
/*756*/ 				} else {
/*756*/ 					m2_print(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\5\0\0\000<sub>", m2runtime_itos(bnf_chk_index), (STRING *) "\0\0\0\0\6\0\0\000</sub>", 1));
/*759*/ 				}
/*759*/ 			}
/*759*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 110) == 1) ){
/*760*/ 			m2_print(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\12\0\0\000 <code><b>", bnf_chk_String2HTML((STRING *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 12, bnf_chk_0err_entry_get, 111)), (STRING *) "\0\0\0\0\13\0\0\000</b></code>", 1));
/*761*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 112) == 4) ){
/*762*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 {");
/*763*/ 			bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 16, bnf_chk_0err_entry_get, 113));
/*764*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 }");
/*765*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 114) == 5) ){
/*766*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 [");
/*767*/ 			bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 16, bnf_chk_0err_entry_get, 115));
/*768*/ 			m2_print((STRING *) "\0\0\0\0\2\0\0\000 ]");
/*769*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 116) == 2) ){
/*770*/ 			{
/*770*/ 				int m2runtime_for_limit_1;
/*770*/ 				bnf_chk_i = 0;
/*770*/ 				m2runtime_for_limit_1 = (m2runtime_count((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 117)) - 1);
/*771*/ 				for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*771*/ 					if( ( *(int *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 118), bnf_chk_i, bnf_chk_0err_entry_get, 119), 24, bnf_chk_0err_entry_get, 120) == 3) ){
/*772*/ 						m2_print((STRING *) "\0\0\0\0\2\0\0\000 (");
/*773*/ 						bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 121), bnf_chk_i, bnf_chk_0err_entry_get, 122));
/*774*/ 						m2_print((STRING *) "\0\0\0\0\2\0\0\000 )");
/*776*/ 					} else {
/*776*/ 						bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 123), bnf_chk_i, bnf_chk_0err_entry_get, 124));
/*779*/ 					}
/*779*/ 				}
/*779*/ 			}
/*779*/ 		} else if( ( *(int *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 24, bnf_chk_0err_entry_get, 125) == 3) ){
/*780*/ 			{
/*780*/ 				int m2runtime_for_limit_1;
/*780*/ 				bnf_chk_i = 0;
/*780*/ 				m2runtime_for_limit_1 = (m2runtime_count((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 126)) - 1);
/*781*/ 				for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*781*/ 					if( (bnf_chk_i > 0) ){
/*782*/ 						m2_print((STRING *) "\0\0\0\0\2\0\0\000 |");
/*784*/ 					}
/*784*/ 					bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_ARRAY((ARRAY *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 20, bnf_chk_0err_entry_get, 127), bnf_chk_i, bnf_chk_0err_entry_get, 128));
/*787*/ 				}
/*787*/ 			}
/*787*/ 		} else {
/*787*/ 			m2_error((STRING *) "\0\0\0\0\23\0\0\000internal error (1)\012");
/*788*/ 			m2runtime_exit(1);
/*791*/ 		}
/*792*/ 	}

/*792*/ 	int bnf_chk_i = 0;
/*794*/ 	RECORD * bnf_chk_d = NULL;
/*794*/ 	{
/*794*/ 		int m2runtime_for_limit_1;
/*794*/ 		bnf_chk_i = 0;
/*794*/ 		m2runtime_for_limit_1 = (m2runtime_count(bnf_chk_decls) - 1);
/*795*/ 		for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*795*/ 			if( bnf_chk_do_print_index ){
/*796*/ 				m2_print(m2runtime_concat_STRING(0, m2runtime_itos((bnf_chk_i + 1)), (STRING *) "\0\0\0\0\2\0\0\000. ", 1));
/*798*/ 			}
/*798*/ 			bnf_chk_d = (RECORD *)m2runtime_dereference_rhs_ARRAY(bnf_chk_decls, bnf_chk_i, bnf_chk_0err_entry_get, 129);
/*799*/ 			m2_print((STRING *)m2runtime_dereference_rhs_RECORD((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 8, bnf_chk_0err_entry_get, 130), 8, bnf_chk_0err_entry_get, 131));
/*800*/ 			m2_print((STRING *) "\0\0\0\0\3\0\0\000 = ");
/*801*/ 			bnf_chk_print_expr((RECORD *)m2runtime_dereference_rhs_RECORD(bnf_chk_d, 12, bnf_chk_0err_entry_get, 132));
/*802*/ 			m2_print((STRING *) "\0\0\0\0\7\0\0\000 ;<br>\012");
/*805*/ 		}
/*805*/ 	}
/*807*/ }


/*809*/ void
/*809*/ bnf_chk_Help(void)
/*809*/ {
/*809*/ 	m2_print(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\10\0\0\000bnf_chk ", (STRING *) "\0\0\0\0\3\0\0\0001.4", (STRING *) "\0\0\0\0\27\0\0\000 - EBNF syntax checker\012", (STRING *) "\0\0\0\0\35\0\0\000Usage: bnf_chk {OPTION} file\012", m2runtime_CHR(10), (STRING *) "\0\0\0\0\23\0\0\000Available options:\012", (STRING *) "\0\0\0\0\55\0\0\000\011--report       Report unused/undeclared ids\012", (STRING *) "\0\0\0\0\42\0\0\000\011--sort         Sort declarations\012", (STRING *) "\0\0\0\0\45\0\0\000\011--print-text   Print decls in ASCII\012", (STRING *) "\0\0\0\0\44\0\0\000\011--print-html   Print decls in HTML\012", (STRING *) "\0\0\0\0\55\0\0\000\011--print-index  Print index numbers of decls\012", (STRING *) "\0\0\0\0\73\0\0\000\011--no-print-file-name Do not print file name in error msgs\012", (STRING *) "\0\0\0\0\57\0\0\000\011--print-source Print source with line numbers\012", (STRING *) "\0\0\0\0\46\0\0\000\011--print-context  Print error context\012", (STRING *) "\0\0\0\0\43\0\0\000\011--help         Displays this help\012", m2runtime_CHR(10), 1));
/*827*/ }


/*829*/ void
/*829*/ bnf_chk_Version(void)
/*829*/ {
/*829*/ 	bnf_chk_print_text(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\10\0\0\000bnf_chk ", (STRING *) "\0\0\0\0\3\0\0\0001.4", (STRING *) "\0\0\0\0\27\0\0\000 - EBNF syntax checker\012", 1));
/*830*/ 	bnf_chk_print_text((STRING *) "\0\0\0\0\105\0\0\000Copyright 2006 by icosaedro.it di Umberto Salsi <salsi@icosaedro.it>\012");
/*831*/ 	bnf_chk_print_text((STRING *) "\0\0\0\0\66\0\0\000More info: http://www.icosaedro.it/bnf_chk/index.html\012");
/*836*/ }

/*837*/ ARRAY * bnf_chk_args = NULL;
/*840*/ int bnf_chk_i = 0;

int bnf_chk_0main()
{
/*841*/ 	bnf_chk_tab_size = 8;
/*842*/ 	bnf_chk_do_sort = FALSE;
/*843*/ 	bnf_chk_do_report = FALSE;
/*844*/ 	bnf_chk_do_print_text = FALSE;
/*845*/ 	bnf_chk_do_print_html = FALSE;
/*846*/ 	bnf_chk_print_file_name = TRUE;
/*847*/ 	bnf_chk_print_source = FALSE;
/*848*/ 	bnf_chk_print_context = FALSE;
/*850*/ 	bnf_chk_args = m2runtime_get_args();
/*851*/ 	{
/*851*/ 		int m2runtime_for_limit_1;
/*851*/ 		bnf_chk_i = 1;
/*851*/ 		m2runtime_for_limit_1 = (m2runtime_count(bnf_chk_args) - 1);
/*852*/ 		for( ; bnf_chk_i <= m2runtime_for_limit_1; bnf_chk_i += 1 ){
/*852*/ 			if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 133), (STRING *) "\0\0\0\0\6\0\0\000--help") == 0 ){
/*853*/ 				bnf_chk_Help();
/*854*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 134), (STRING *) "\0\0\0\0\11\0\0\000--version") == 0 ){
/*855*/ 				bnf_chk_Version();
/*856*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 135), (STRING *) "\0\0\0\0\6\0\0\000--sort") == 0 ){
/*857*/ 				bnf_chk_do_sort = TRUE;
/*858*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 136), (STRING *) "\0\0\0\0\10\0\0\000--report") == 0 ){
/*859*/ 				bnf_chk_do_report = TRUE;
/*860*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 137), (STRING *) "\0\0\0\0\14\0\0\000--print-text") == 0 ){
/*861*/ 				bnf_chk_do_print_text = TRUE;
/*862*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 138), (STRING *) "\0\0\0\0\14\0\0\000--print-html") == 0 ){
/*863*/ 				bnf_chk_do_print_html = TRUE;
/*864*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 139), (STRING *) "\0\0\0\0\15\0\0\000--print-index") == 0 ){
/*865*/ 				bnf_chk_do_print_index = TRUE;
/*866*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 140), (STRING *) "\0\0\0\0\24\0\0\000--no-print-file-name") == 0 ){
/*867*/ 				bnf_chk_print_file_name = FALSE;
/*868*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 141), (STRING *) "\0\0\0\0\16\0\0\000--print-source") == 0 ){
/*869*/ 				bnf_chk_print_source = TRUE;
/*870*/ 			} else if( m2runtime_strcmp((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 142), (STRING *) "\0\0\0\0\17\0\0\000--print-context") == 0 ){
/*871*/ 				bnf_chk_print_context = TRUE;
/*872*/ 			} else if( m2runtime_strcmp(m2runtime_substr((STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 143), 0, 0, 0, bnf_chk_0err_entry_get, 144), m2runtime_CHR(45)) == 0 ){
/*873*/ 				m2_error(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\26\0\0\000ERROR: unknown option ", (STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 145), m2runtime_CHR(10), 1));
/*874*/ 				m2runtime_exit(1);
/*876*/ 			} else {
/*876*/ 				if( bnf_chk_fn != NULL ){
/*877*/ 					m2_error(m2runtime_concat_STRING(0, (STRING *) "\0\0\0\0\21\0\0\000ERROR: parameter ", (STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 146), (STRING *) "\0\0\0\0\33\0\0\000: file name already set to ", bnf_chk_fn, m2runtime_CHR(10), 1));
/*879*/ 					m2_error((STRING *) "\0\0\0\0\112\0\0\000Please type \042bnf_chk --help\042 for a complete list of the available options\012");
/*880*/ 					m2runtime_exit(1);
/*882*/ 				}
/*882*/ 				bnf_chk_fn = (STRING *)m2runtime_dereference_rhs_ARRAY(bnf_chk_args, bnf_chk_i, bnf_chk_0err_entry_get, 147);
/*885*/ 			}
/*885*/ 		}
/*885*/ 	}
/*885*/ 	if( bnf_chk_fn == NULL ){
/*886*/ 		m2_error((STRING *) "\0\0\0\0\32\0\0\000ERROR: required file name\012");
/*887*/ 		m2runtime_exit(1);
/*889*/ 	}
/*889*/ 	bnf_chk_ids = NULL;
/*890*/ 	bnf_chk_decls = NULL;
/*891*/ 	bnf_chk_read_decls(bnf_chk_fn);
/*892*/ 	if( bnf_chk_do_report ){
/*892*/ 		bnf_chk_ids_report();
/*893*/ 	}
/*893*/ 	if( bnf_chk_do_sort ){
/*893*/ 		bnf_chk_sort_decls(bnf_chk_decls);
/*894*/ 	}
/*894*/ 	if( bnf_chk_do_print_text ){
/*894*/ 		bnf_chk_print_as_text(bnf_chk_decls);
/*895*/ 	}
/*895*/ 	if( bnf_chk_do_print_html ){
/*895*/ 		bnf_chk_print_as_html(bnf_chk_decls);
/*897*/ 	}
	return 0;
}

char * bnf_chk_0func[] = {
    "read_ch",
    "hex",
    "read_lit_string",
    "add_id",
    "ids_report",
    "read_factor",
    "read_termin",
    "read_expr",
    "read_decl",
    "read_decls",
    "sort_decls",
    "print_expr",
    "print_as_text",
    "print_expr",
    "print_as_html",
    "0main"
};

int bnf_chk_0err_entry[] = {
    0 /* read_ch */, 153,
    0 /* read_ch */, 159,
    0 /* read_ch */, 165,
    1 /* hex */, 241,
    2 /* read_lit_string */, 304,
    3 /* add_id */, 459,
    3 /* add_id */, 459,
    3 /* add_id */, 461,
    3 /* add_id */, 465,
    3 /* add_id */, 466,
    3 /* add_id */, 467,
    3 /* add_id */, 468,
    3 /* add_id */, 470,
    3 /* add_id */, 471,
    3 /* add_id */, 472,
    3 /* add_id */, 473,
    3 /* add_id */, 473,
    3 /* add_id */, 475,
    3 /* add_id */, 478,
    3 /* add_id */, 480,
    3 /* add_id */, 483,
    3 /* add_id */, 484,
    3 /* add_id */, 487,
    3 /* add_id */, 487,
    4 /* ids_report */, 500,
    4 /* ids_report */, 500,
    4 /* ids_report */, 500,
    4 /* ids_report */, 501,
    4 /* ids_report */, 502,
    4 /* ids_report */, 503,
    4 /* ids_report */, 507,
    4 /* ids_report */, 508,
    5 /* read_factor */, 536,
    5 /* read_factor */, 538,
    5 /* read_factor */, 544,
    5 /* read_factor */, 546,
    5 /* read_factor */, 552,
    5 /* read_factor */, 553,
    5 /* read_factor */, 556,
    5 /* read_factor */, 558,
    5 /* read_factor */, 566,
    5 /* read_factor */, 566,
    6 /* read_termin */, 589,
    6 /* read_termin */, 590,
    6 /* read_termin */, 590,
    6 /* read_termin */, 591,
    6 /* read_termin */, 591,
    6 /* read_termin */, 599,
    6 /* read_termin */, 599,
    6 /* read_termin */, 599,
    6 /* read_termin */, 601,
    7 /* read_expr */, 608,
    7 /* read_expr */, 609,
    7 /* read_expr */, 609,
    7 /* read_expr */, 614,
    7 /* read_expr */, 614,
    7 /* read_expr */, 614,
    8 /* read_decl */, 626,
    8 /* read_decl */, 632,
    9 /* read_decls */, 646,
    9 /* read_decls */, 649,
    9 /* read_decls */, 659,
    9 /* read_decls */, 659,
    9 /* read_decls */, 660,
    10 /* sort_decls */, 670,
    10 /* sort_decls */, 670,
    10 /* sort_decls */, 670,
    10 /* sort_decls */, 670,
    10 /* sort_decls */, 670,
    10 /* sort_decls */, 670,
    10 /* sort_decls */, 672,
    10 /* sort_decls */, 672,
    10 /* sort_decls */, 673,
    10 /* sort_decls */, 673,
    10 /* sort_decls */, 676,
    10 /* sort_decls */, 676,
    10 /* sort_decls */, 676,
    11 /* print_expr */, 686,
    11 /* print_expr */, 687,
    11 /* print_expr */, 687,
    11 /* print_expr */, 689,
    11 /* print_expr */, 689,
    11 /* print_expr */, 696,
    11 /* print_expr */, 697,
    11 /* print_expr */, 698,
    11 /* print_expr */, 700,
    11 /* print_expr */, 702,
    11 /* print_expr */, 704,
    11 /* print_expr */, 706,
    11 /* print_expr */, 707,
    11 /* print_expr */, 708,
    11 /* print_expr */, 708,
    11 /* print_expr */, 708,
    11 /* print_expr */, 710,
    11 /* print_expr */, 710,
    11 /* print_expr */, 713,
    11 /* print_expr */, 713,
    11 /* print_expr */, 716,
    11 /* print_expr */, 717,
    11 /* print_expr */, 721,
    11 /* print_expr */, 721,
    12 /* print_as_text */, 736,
    12 /* print_as_text */, 736,
    12 /* print_as_text */, 736,
    12 /* print_as_text */, 738,
    13 /* print_expr */, 749,
    13 /* print_expr */, 750,
    13 /* print_expr */, 750,
    13 /* print_expr */, 752,
    13 /* print_expr */, 752,
    13 /* print_expr */, 759,
    13 /* print_expr */, 760,
    13 /* print_expr */, 761,
    13 /* print_expr */, 763,
    13 /* print_expr */, 765,
    13 /* print_expr */, 767,
    13 /* print_expr */, 769,
    13 /* print_expr */, 770,
    13 /* print_expr */, 771,
    13 /* print_expr */, 771,
    13 /* print_expr */, 771,
    13 /* print_expr */, 773,
    13 /* print_expr */, 773,
    13 /* print_expr */, 776,
    13 /* print_expr */, 776,
    13 /* print_expr */, 779,
    13 /* print_expr */, 780,
    13 /* print_expr */, 784,
    13 /* print_expr */, 784,
    14 /* print_as_html */, 799,
    14 /* print_as_html */, 799,
    14 /* print_as_html */, 799,
    14 /* print_as_html */, 801,
    15 /* 0main */, 852,
    15 /* 0main */, 854,
    15 /* 0main */, 856,
    15 /* 0main */, 858,
    15 /* 0main */, 860,
    15 /* 0main */, 862,
    15 /* 0main */, 864,
    15 /* 0main */, 866,
    15 /* 0main */, 868,
    15 /* 0main */, 870,
    15 /* 0main */, 872,
    15 /* 0main */, 872,
    15 /* 0main */, 873,
    15 /* 0main */, 878,
    15 /* 0main */, 883
};

void bnf_chk_0err_entry_get(int i, char **m, char **f, int *l)
{
    *m = "bnf_chk";
    *f = bnf_chk_0func[ bnf_chk_0err_entry[2*i] ];
    *l = bnf_chk_0err_entry[2*i + 1];
}

int main(int argc, char *argv[])
{
	m2runtime_argc = argc;  m2runtime_argv = argv;
	GC_INIT();
	return bnf_chk_0main();
}

/* END */
